unit PDB;

interface

const
  kMaxPDBNameSize = 32;
  kPDBNameSuffix  = '.PDB';
  kDOSFilenameSize = 12;

  timeOffset  = 2082844886;//LU      /* Time offset from Unix time() values */
type
  PDBHeader=record
        //name:array[0..kMaxPDBNameSize] of char;    //32
        name:string[kMaxPDBNameSize];    //32
        flags:word;                                //2
        version:word;                              //2
        creationTime:Longword;
        modificationTime:Longword;
        backupTime:Longword;
        modificationNumber:Longword;
        appInfoOffset:Longword;
        sortInfoOffset:Longword;
        ltype:array[0..3] of char;                   //10*x+3*y=46
        creator:array[0..3] of char;                //x=(46-3*y)/10 x = 2 (16 )
        uniqueID:Longword;
        nextRecordID:Longword;
        numRecords:word;
  end;

const
  kPDBHeaderSize  = 78;
            
type

  PDBResourceEntry = record
        _type  : Longword;
        id     : word;
        offset : Longword;
  end;

const
  kPDBResourceEntrySize = 10;

type
  PDBRecordEntry = record
        offset : Longword;
        attr : word;
        uniqueID : Longword;	//:24 ;
  end;

const
  dmRecAttrDelete = $080;//    /* Delete this record on next sync */
  dmRecAttrDirty  = $040;//    /* Archive this record on next sync */
  dmRecAttrBusy   = $020;//    /* Record is in use */
  dmRecAttrSecret = $010;//    /* Secret record, protected by password */

  dmRecAttrCategoryMask = $00F; ///* Mask to extract category from attribute */

  kPDBRecordEntrySize = 8;

{      PDB Format

        PBDHeader
        PDBResourceEntry|PDBRecordEntry [numRecords]
        2 bytes
        AppInfo (if applicable)
        SortInfo (if applicable)
        DATA ENTRIES
}

  kPDBFirstResourceOffset = (kPDBHeaderSize + kPDBResourceEntrySize + 2);
  kPDBFirstRecordOffset   = (kPDBHeaderSize + kPDBRecordEntrySize + 2);

//enum PDBFlags {
  pdbResourceFlag = $00001;//          /* Is this a resource file ? */
  pdbReadOnlyFlag = $00002;//          /* Is database read only ? */
  pdbAppInfoDirtyFlag = $00004;//      /* Is application info block dirty ? */
  pdbBackupFlag = $00008;//            /* Back up to PC if no conduit defined */
  pdbOKToInstallNewer = $00010;//      /* OK to install a newer version if current database open */
  pdbResetAfterInstall = $00020;//     /* Must reset machine after installation */
  pdbStream = $00080;//                /* Used for file streaming */
  pdbOpenFlag = $08000;//               /* Not closed properly */

//enum PDBVersion {
  pdbVerReadOnly = $00001;
  pdbVerWrite = $00002;
  pdbVerReadWrite = $00003;
  pdbVerLeaveOpen = $00004;
  pdbVerExclusive = $00008;
  pdbVerShowSecret = $00010;
implementation

end.
